.586
option casemap:none
include \masm32\include\masm32rt.inc
SHA256Init proto
SHA256Update proto:dword,:dword
SHA256Block proto:dword,:dword
.data
 FileName db 'C:\ydctemp\a.txt',0
 align 4
 sha256_table label dword
  dd 0428a2f98h,071374491h,0b5c0fbcfh,0e9b5dba5h,03956c25bh,059f111f1h,0923f82a4h,0ab1c5ed5h
  dd 0d807aa98h,012835b01h,0243185beh,0550c7dc3h,072be5d74h,080deb1feh,09bdc06a7h,0c19bf174h
  dd 0e49b69c1h,0efbe4786h,00fc19dc6h,0240ca1cch,02de92c6fh,04a7484aah,05cb0a9dch,076f988dah
  dd 0983e5152h,0a831c66dh,0b00327c8h,0bf597fc7h,0c6e00bf3h,0d5a79147h,006ca6351h,014292967h
  dd 027b70a85h,02e1b2138h,04d2c6dfch,053380d13h,0650a7354h,0766a0abbh,081c2c92eh,092722c85h
  dd 0a2bfe8a1h,0a81a664bh,0c24b8b70h,0c76c51a3h,0d192e819h,0d6990624h,0f40e3585h,0106aa070h
  dd 019a4c116h,01e376c08h,02748774ch,034b0bcb5h,0391c0cb3h,04ed8aa4ah,05b9cca4fh,0682e6ff3h
  dd 0748f82eeh,078a5636fh,084c87814h,08cc70208h,090befffah,0a4506cebh,0bef9a3f7h,0c67178f2h
.data?
 hFile dd ?
 szBuffer db 4096 dup(?)
 dwRead dd ?
 align 4
 RESULT dd 8 dup(?)
.code
 start:
 invoke CreateFile,addr FileName,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
 mov hFile,eax
 cmp eax,-1
 je HandleErr
 invoke SHA256Init
 @@:
 invoke ReadFile,hFile,addr szBuffer,sizeof szBuffer,addr dwRead,0
 test eax,eax
 je ReadErr
 invoke SHA256Update,addr szBuffer,dwRead
 .if dwRead<sizeof szBuffer
  jmp @f
 .endif
 jmp @b
 @@:
 print uhex$([RESULT])
 print uhex$([RESULT+4])
 print uhex$([RESULT+8])
 print uhex$([RESULT+12])
 print uhex$([RESULT+16])
 print uhex$([RESULT+20])
 print uhex$([RESULT+24])
 print uhex$([RESULT+28])
 ReadErr:
 invoke CloseHandle,hFile
 HandleErr:
 inkey chr$(13,10,"Press any key to exit...")
 exit
 SHA256Init proc
  mov edx,offset RESULT
  mov dword ptr [edx],06a09e667h
   ;Set initial values for the hash.
  mov dword ptr [edx+4],0bb67ae85h
  mov dword ptr [edx+8],03c6ef372h
  mov dword ptr [edx+12],0a54ff53ah
  mov dword ptr [edx+16],0510e527fh
  mov dword ptr [edx+20],09b05688ch
  mov dword ptr [edx+24],01f83d9abh
  mov dword ptr [edx+28],05be0cd19h
  ret
 SHA256Init endp
 SHA256Update proc uses edi esi lpBuffer:dword,dwBufLen:dword
  local rgTempMem[128]:byte
  mov edi,dwBufLen
  mov esi,lpBuffer
  shr edi,6
  jz @partial_block
  @@:
  invoke SHA256Block,esi,offset RESULT
  add esi,64
  dec edi
  jnz @b
  @partial_block:
  mov ecx,dwBufLen
  lea edi,dword ptr [rgTempMem]
  and ecx,3Fh
  push offset RESULT
  push edi
  mov eax,ecx
  cld
  rep movsb
  mov byte ptr [edi],80h
  inc edi
  mov ecx,eax
  xor eax,eax
  bswap esi
  sub ecx,55
  ja @f
  neg ecx
  rep stosb
  jmp @finalize
  @@:
  sub ecx,64
  neg ecx
  rep stosb
  call SHA256Block
  lea edx,[rgTempMem+64]
  push offset RESULT
  push edx
  @finalize:
  mov esi,dwBufLen
  mov eax,esi
  rol esi,3
  shl eax,3
  and esi,7h
  bswap eax
  bswap esi
  mov dword ptr [edi+4],eax
  mov dword ptr [edi],esi
  call SHA256Block
  @sha_done:
  ret
 SHA256Update endp
 option prologue:none
 option epilogue:none
 SHA256Block proc lpSource:dword,lpHash:dword
  $_b equ <esp+10h>
  $_c equ <esp+14h>
  $_d equ <esp+18h>
  $_f equ <esp+1Ch>
  $_g equ <esp+20h>
  $_h equ <esp+24h>
  $W equ <esp+28h>
  $lpHash equ <esp+130h>
  $lpSource equ <esp+12Ch>
  sub esp,128h
  mov dword ptr [esp+0Ch],ebp
  mov dword ptr [esp+08h],ebx
  mov dword ptr [esp+04h],edi
  mov dword ptr [esp],esi
  mov esi,[$lpSource]
  mov eax,dword ptr [esi+0]
  mov ebx,dword ptr [esi+4]
  mov ecx,dword ptr [esi+8]
  mov edx,dword ptr [esi+12]
  mov ebp,dword ptr [esi+16]
  mov edi,dword ptr [esi+20]
  bswap eax
  bswap ebx
  bswap ecx
  bswap edx
  bswap ebp
  bswap edi
  mov dword ptr [$W+0],eax
  mov dword ptr [$W+4],ebx
  mov dword ptr [$W+8],ecx
  mov dword ptr [$W+12],edx
  mov dword ptr [$W+16],ebp
  mov dword ptr [$W+20],edi
  mov eax,dword ptr [esi+24]
  mov ebx,dword ptr [esi+28]
  mov ecx,dword ptr [esi+32]
  mov edx,dword ptr [esi+36]
  mov ebp,dword ptr [esi+40]
  mov edi,dword ptr [esi+44]
  bswap eax
  bswap ebx
  bswap ecx
  bswap edx
  bswap ebp
  bswap edi
  mov dword ptr [$W+24],eax
  mov dword ptr [$W+28],ebx
  mov dword ptr [$W+32],ecx
  mov dword ptr [$W+36],edx
  mov dword ptr [$W+40],ebp
  mov dword ptr [$W+44],edi
  mov eax,dword ptr [esi+48]
  mov ebx,dword ptr [esi+52]
  mov ecx,dword ptr [esi+56]
  mov edx,dword ptr [esi+60]
  bswap eax
  bswap ebx
  bswap ecx
  bswap edx
  mov dword ptr [$W+48],eax
  mov dword ptr [$W+52],ebx
  mov dword ptr [$W+56],ecx
  mov dword ptr [$W+60],edx
  mov ecx,0FFFFFF40h
  mov esi,[$lpHash]
  align 16
  @@:
  mov eax,dword ptr [$W+ecx-15*4+256]
  mov ebx,dword ptr [$W+ecx-2*4+256]
  mov edi,dword ptr [$W+ecx-7*4+256]
  mov ebp,eax
  mov edx,ebx
  ror eax,7
  shr ebp,3
  ror ebx,17
  shr edx,10
  xor ebp,eax
  ror eax,11
  xor edx,ebx
  ror ebx,2
  xor eax,ebp
  add edi,dword ptr [$W+ecx-16*4+256]
  xor ebx,edx
  add edi,eax
  add edi,ebx
  mov dword ptr [$W+ecx+256],edi
  add ecx,4
  jne @b
  mov eax,dword ptr [esi]
  mov ebx,dword ptr [esi+4]
  mov ecx,dword ptr [esi+8]
  mov edx,dword ptr [esi+12]
  mov ebp,dword ptr [esi+16]
  mov edi,dword ptr [esi+20]
  mov dword ptr [$_b],ebx
  mov dword ptr [$_c],ecx
  mov dword ptr [$_d],edx
  mov dword ptr [$_f],edi
  mov ebx,dword ptr [esi+24]
  mov edx,dword ptr [esi+28]
  mov dword ptr [$_g],ebx
  mov ecx,0FFFFFF00h
  align 16
  @@:
  mov ebx,ebp
  add edx,dword ptr [$W+ecx+256]
  mov edi,ebp
  ror ebx,6
  mov esi,ebp
  ror edi,11
  add edx,dword ptr [sha256_table+ecx+256]
  ror esi,25
  xor ebx,edi
  mov edi,dword ptr [$_g]
  xor ebx,esi
  mov esi,dword ptr [$_f]
  mov dword ptr [$_f],ebp
  mov dword ptr [$_g],esi
  xor esi,edi
  mov dword ptr [$_h],edi
  add edx,ebx
  and esi,ebp
  mov ebx,dword ptr [$_b]
  xor esi,edi
  mov edi,dword ptr [$_c]
  add edx,esi
  mov ebp,ebx
  mov dword ptr [$_c],ebx
  xor ebx,eax
  mov dword ptr [$_b],eax
  and ebp,eax
  and ebx,edi
  mov esi,eax
  add ebx,ebp
  ror esi,2
  mov ebp,eax
  ror eax,13
  xor eax,esi
  ror ebp,22
  xor eax,ebp
  mov ebp,dword ptr [$_d]
  mov dword ptr [$_d],edi
  add ebp,edx
  add eax,edx
  mov edx,dword ptr [$_h]
  add eax,ebx
  add ecx,4
  jne @b
  mov esi,dword ptr [$lpHash]
  mov ebx,dword ptr [$_b]
  mov ecx,dword ptr [$_c]
  add dword ptr [esi],eax
  add dword ptr [esi+4],ebx
  mov ebx,dword ptr [$_f]
  mov eax,dword ptr [$_g]
  add dword ptr [esi+8],ecx
  add dword ptr [esi+12],edi
  add dword ptr [esi+16],ebp
  add dword ptr [esi+20],ebx
  add dword ptr [esi+24],eax
  add dword ptr [esi+28],edx
  mov esi,dword ptr [esp]
  mov edi,dword ptr [esp+4h]
  mov ebx,dword ptr [esp+8h]
  mov ebp,dword ptr [esp+0Ch]
  add esp,128h
  ret 8
 SHA256Block endp
 option prologue:prologuedef
 option epilogue:epiloguedef
end start